import com.sun.j3d.utils.universe.SimpleUniverse;
import javax.vecmath.*;
import javax.swing.*;

public class WorldFrame extends java.awt.Frame {
    
    robotWorldCanvas world1;
    TopWorldCanvas world2;
    ThirdViewWorldCanvas world3;
   
    public WorldFrame() {
        initComponents();
        world1 = new robotWorldCanvas(SimpleUniverse.getPreferredConfiguration());
        world1.setSize(240,240);
        panel2.add(world1);
        world2 = new TopWorldCanvas(SimpleUniverse.getPreferredConfiguration());
        world2.setSize(240,240);
        panel3.add(world2);
        world3 = new ThirdViewWorldCanvas(SimpleUniverse.getPreferredConfiguration());
        world3.setSize(240,240);
        panel4.add(world3);
        
    }
        
    
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        panel1 = new java.awt.Panel();
        button1 = new java.awt.Button();
        button3 = new java.awt.Button();
        button2 = new java.awt.Button();
        button4 = new java.awt.Button();
        button5 = new java.awt.Button();
        button6 = new java.awt.Button();
        button9 = new java.awt.Button();
        panel3 = new java.awt.Panel();
        panel2 = new java.awt.Panel();
        panel4 = new java.awt.Panel();

        setLayout(new java.awt.GridBagLayout());

        setResizable(false);
        setTitle("NSLWorld");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        panel1.setLayout(new java.awt.GridBagLayout());

        button1.setLabel("Archivo");
        button1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        panel1.add(button1, gridBagConstraints);

        button3.setLabel("-");
        button3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button3ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        panel1.add(button3, gridBagConstraints);

        button2.setLabel("<");
        button2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button2ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        panel1.add(button2, gridBagConstraints);

        button4.setLabel(">");
        button4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button4ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        panel1.add(button4, gridBagConstraints);

        button5.setLabel("/\\");
            button5.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    button5ActionPerformed(evt);
                }
            });

            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 3;
            gridBagConstraints.gridy = 1;
            panel1.add(button5, gridBagConstraints);

            button6.setLabel("\\/");
            button6.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    button6ActionPerformed(evt);
                }
            });

            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 3;
            gridBagConstraints.gridy = 2;
            panel1.add(button6, gridBagConstraints);

            button9.setLabel("+");
            button9.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    button9ActionPerformed(evt);
                }
            });

            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 2;
            gridBagConstraints.gridy = 1;
            panel1.add(button9, gridBagConstraints);

            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 1;
            add(panel1, gridBagConstraints);

            panel3.setBackground(new java.awt.Color(255, 204, 0));
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 2;
            gridBagConstraints.gridy = 0;
            add(panel3, gridBagConstraints);

            panel2.setBackground(new java.awt.Color(153, 244, 51));
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 0;
            gridBagConstraints.gridy = 0;
            add(panel2, gridBagConstraints);

            panel4.setBackground(new java.awt.Color(204, 153, 0));
            gridBagConstraints = new java.awt.GridBagConstraints();
            gridBagConstraints.gridx = 2;
            gridBagConstraints.gridy = 1;
            add(panel4, gridBagConstraints);

            java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
            setBounds((screenSize.width-510)/2, (screenSize.height-510)/2, 510, 510);
        }

    private void button2ActionPerformed(java.awt.event.ActionEvent evt) {
        world1.moveCamera(new Vector3f(-0.1f,0f,0f));
        world1.moveRobot(new Vector3f(-0.1f,0f,0f));
        world2.moveRobot(new Vector3f(-0.1f,0f,0f));
        world3.moveRobot(new Vector3f(-0.1f,0f,0f));
    }

    private void button4ActionPerformed(java.awt.event.ActionEvent evt) {
        world1.moveCamera(new Vector3f(0.1f,0f,0f));
        world1.moveRobot(new Vector3f(0.1f,0f,0f));
        world2.moveRobot(new Vector3f(0.1f,0f,0f));
        world3.moveRobot(new Vector3f(0.1f,0f,0f));
    }

    private void button6ActionPerformed(java.awt.event.ActionEvent evt) {
        world1.moveCamera(new Vector3f(0f,0f,0.1f));
        world1.moveRobot(new Vector3f(0f,0f,0.1f));
        world2.moveRobot(new Vector3f(0f,0f,0.1f));
        world3.moveRobot(new Vector3f(0f,0f,0.1f));
    }

    private void button9ActionPerformed(java.awt.event.ActionEvent evt) {
        world2.moveCamera(new Vector3f(0f, -1f, 0f));
    }

    private void button5ActionPerformed(java.awt.event.ActionEvent evt) {
        world1.moveCamera(new Vector3f(0f,0f,-0.1f));
        world1.moveRobot(new Vector3f(0f,0f,-0.1f));
        world2.moveRobot(new Vector3f(0f,0f,-0.1f));
        world3.moveRobot(new Vector3f(0f,0f,-0.1f));
    }

    private void button3ActionPerformed(java.awt.event.ActionEvent evt) {
        world2.moveCamera(new Vector3f(0f, 1f, 0f));        
    }

    private void button1ActionPerformed(java.awt.event.ActionEvent evt) {
        openFile();
    }
    
    private void openFile() {
        JFileChooser chooser = new JFileChooser();
       
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            WorldConstructor constr = new WorldConstructor(chooser.getSelectedFile().getAbsoluteFile().toString());
            world1.setBranchGroup(constr.getFrontGroup());
            world2.setBranchGroup(constr.getTopGroup());
            world3.setBranchGroup(constr.getLastGroup());
        }
    }
    
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }
    
    public static void main(String args[]) {
        new WorldFrame().show();
    }
    
    float angle2 = 0;
    public void rotateRobot(float angle) {
        angle2 += angle;
        
        world2.moveRobotBody(-angle);
        world3.moveRobotBody(-angle);
        world1.moveRobotBody(-angle);
        world1.moveCamera(-angle);
    }
    
    //Alejandra Barrera
    //Mover desde World slo la cmara del robot y tomar tres snapshots
    public void rotateRobotCamera(float angle)
    {
        world1.moveCamera(-angle);
    }
    
    public void moveRobot(double x, double y, double z, float angle) 
    {
        world1.moveCamera(new Vector3f((float)x,(float)y,(float)z));
        world1.moveRobot(new Vector3f((float)x,(float)y,(float)z));
        world2.moveRobot(new Vector3f((float)x,(float)y,(float)z));
        world3.moveRobot(new Vector3f((float)x,(float)y,(float)z));
    }

    public void moveFood(double x, double y, double z) 
    {
        world1.moveFood(new Vector3f((float)x,(float)y,(float)z));
        world2.moveFood(new Vector3f((float)x,(float)y,(float)z));
        world3.moveFood(new Vector3f((float)x,(float)y,(float)z));
    }
    public void startRobot(double x, double y, double z) {
        world1.startCamera(new Vector3f((float)x,(float)y,(float)z));
        world1.startRobot(new Vector3f((float)x,(float)y,(float)z));
        world2.startRobot(new Vector3f((float)x,(float)y,(float)z));
        world3.startRobot(new Vector3f((float)x,(float)y,(float)z));
    }
    public boolean isCollided() {
        return world1.isCollided();
    }
    
    public int[][] getColorMatrix() {
        return world1.getColorMatrix();
    }
    
    
    private java.awt.Button button1;
    private java.awt.Button button2;
    private java.awt.Button button3;
    private java.awt.Button button4;
    private java.awt.Button button5;
    private java.awt.Button button6;
    private java.awt.Button button9;
    private java.awt.Panel panel1;
    private java.awt.Panel panel2;
    private java.awt.Panel panel3;
    private java.awt.Panel panel4;
    
}
